package com.nationrel.modules.project.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.nationrel.modules.project.dto.PmTaskInfoDto;
import com.nationrel.modules.project.entity.PmTaskInfo;
import com.nationrel.modules.project.jar.dto.input.Rb0300220InitInput;
import com.nationrel.modules.project.jar.dto.output.Rb0300220InitOutput;
import com.nationrel.modules.project.jar.entity.TaskPageModel;
import com.nationrel.modules.project.jar.rb_common.common.constant.ReliaFlowConstants;
import com.nationrel.modules.project.jar.service.Rb0300220InitService;
import com.nationrel.modules.project.mapper.PmTaskInfoMapper;
import com.nationrel.modules.project.service.IPmTaskInfoService;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * @Description: t_pm_tg
 * @Author: nationrel
 * @Date:   2024-10-23
 * @Version: V1.0
 */
@Service
public class PmTaskInfoServiceImpl extends ServiceImpl<PmTaskInfoMapper, PmTaskInfo> implements IPmTaskInfoService {

    @Autowired
    private PmTaskInfoMapper pmTaskInfoMapper;
    @Autowired
    private Rb0300220InitService rb0300220InitService;

    @Override
    public IPage<PmTaskInfoDto> selectPmTaskInfoPage(Page page, String projectId) {

        PmTaskInfoDto pmTaskInfoDto = pmTaskInfoMapper.selectPmProjectInfoById(projectId);
        IPage<PmTaskInfoDto> pmTaskInfoDtoIPage = pmTaskInfoMapper.selectPmTaskInfoList(page, projectId);

        if (!CollectionUtils.isEmpty(pmTaskInfoDtoIPage.getRecords())) {
            pmTaskInfoDtoIPage.getRecords().forEach(item -> {
                Rb0300220InitInput input = new Rb0300220InitInput();
                Rb0300220InitOutput output = new Rb0300220InitOutput();
                input.setTgId(item.getTgId());
                input.setProjectId(item.getProjectId());
                try {
                    Rb0300220InitOutput children = rb0300220InitService.perform(input, output);
                    if (ObjectUtils.isNotEmpty(children) && !CollectionUtils.isEmpty(children.getTasks())) {
                        item.setChildTask(getChildTask(children.getTasks()));
//                        item.setChildTask(children.getTasks());
                        /*List<TaskPageModel> parent = children.getTasks().stream().filter(item -> item.getParentTaskId().equals(ReliaFlowConstants.TASK_FIRST_PARENT_ID)).toList();
                        if (!CollectionUtils.isEmpty(parent)) {
                            parent.forEach(it -> {
                                it.setChildTask(children.getTasks().stream().filter(child -> child.getParentTaskId().equals(it.getTaskId())).toList());
                            });
                        }*/

                    }
                } catch (Exception e) {
                    log.error("子任务查询异常", e);
                }
            });
        }

        pmTaskInfoDtoIPage.getRecords().add(0, pmTaskInfoDto);
        return pmTaskInfoDtoIPage;
    }

    private List<TaskPageModel> getChildTask(List<TaskPageModel> taskPageModels) {
        List<TaskPageModel> parent = taskPageModels.stream().filter(item -> item.getParentTaskId().equals(ReliaFlowConstants.TASK_FIRST_PARENT_ID)).toList();
        if (!CollectionUtils.isEmpty(parent)) {
            parent.forEach(it -> {
                List<TaskPageModel> list = taskPageModels.stream().filter(child -> child.getParentTaskId().equals(it.getTaskId())).toList();
                if (!CollectionUtils.isEmpty(list)) {
                    it.setChildren(list);
                }
            });
        }
        return parent;
    }
}
